.plugin asm83p

_ClearRect         .equ 4D5Ch ; Draw a rectangle (Upper Left L,H, Lower Right E,D)
_contrast          .equ 8447h ; RAM addr where contrast value is kept.
_ConvOP1           .equ 4AEFh ; puts value of OP1 into de
_GetLtoOP1         .equ 4636h ; gets list element (hl) into Op1
_DrawRectBorder    .equ 4D7Dh ; Draw a rectangle (Upper Left L,H, Lower Right E,D)
_DrawRectBorderClr .equ 4D8Ch ; Draw a rectangle (Upper Left L,H, Lower Right E,D)
_EraseRectBorder   .equ 4D86h ; Draw a rectangle (Upper Left L,H, Lower Right E,D)
_FPMult            .equ 4084h ; do floating point multiplication OP1 * OP2
_FillRect          .equ 4D62h ; Draw a rectangle (Upper Left L,H, Lower Right E,D)
_InvertRect        .equ 4D5Fh ; Draw a inverted rectangle (Upper Left L,H, Lower Right E,D)
_MemChk            .equ 42E5h ; checks amount of free ram
_MemClear          .equ 4C30h ; erases some bytes (de), starting at a point in memory (hl)
_OP2ToOP1          .equ 4156h ; puts 11 bytes from OP2 into OP1
_plotscreen        .equ 9340h ; ram addr where the graphscreen is stored
_appbackupscreen   .equ 9872h
_SaveSScreen       .equ 86ECh
_RclAns            .equ 4AD7h ; recalls the value in Ans to OP1
_runIndicOff       .equ 4570h ; Turn the running icon off
_SetXXXXOP2        .equ 4792h ; puts a 32-bit number into OP2
_StoN              .equ 4ACBh ; store the value in OP1 to statistical n
_Times2            .equ 4066h ; multiply the value in OP1 by 2

.org 9D95h

 rst 28h
.dw _runIndicOff
 call GetAns1
 ld a,e
 or a
 call z,Inverse
; cp 1
; call z,ShowPic
 cp 2
 call z,ShiftScreen
 cp 3
 call z,InvText
 cp 4
 call z,AlphaLock
 cp 5
 call z,DrawSquare
 cp 6
 call z,FadeOut
 cp 7
 call z,GetFreeRAM
 cp 8
 call z,GetFreeArc
 cp 9
 call z,ContNew
 cp 10
 call z,NoDone
 cp 11
 call z,UserSprite
 ret

ShiftScreen:
 call GetAns2
 ld a,e
 or a
 call z,ShiftUp
 cp 1
 call z,ShiftDown
 cp 2
 call z,ShiftRight
 cp 3
 call z,ShiftLeft
 ret
 
GetFreeArc:
 rst 28h
.dw 5014h
 ld hl,839Fh
 ld d,(hl)
 inc hl
 ld e,(hl)
 inc hl
 ld b,(hl)
 inc hl
 ld c,(hl)
 push bc
 ex de,hl
 rst 28h
.dw _SetXXXXOP2
 rst 28h
.dw _OP2ToOP1
 ld hl,32768
 rst 28h
.dw _SetXXXXOP2
 rst 28h
.dw _FPMult
 rst 28h
.dw _Times2
 pop hl
 rst 28h
.dw _SetXXXXOP2
 rst 30h
 rst 28h
.dw _StoN
 ret

ContNew:
 call GetAns2
 ld a,e
 or a
 call z,ContDown
 cp 1
 call z,ContUp
 ret
 
ContUp:
 ld hl,_contrast
 ld a,(hl)
 add a,4
 cp 28h
 ret nc
 push af
NewCont:
 pop af
 ld (hl),a
 add a,$D8
 call 0Bh
 out (10h),a
 ret

ContDown:
 ld hl,_contrast
 ld a,(hl)
 sub 4
 ret c
 push af
 jr NewCont

GetFreeRAM:
 rst 28h
.dw _MemChk
 rst 28h
.dw _SetXXXXOP2
 rst 28h
.dw _OP2ToOP1
 rst 28h
.dw _StoN
 ret
 
FadeOut:
 ld hl,_plotscreen
 ld bc,$0300
 push hl
 push bc
FadeLoop07:
 res 0,(hl)
 res 7,(hl)
 inc hl
 dec bc
 ld a,b
 or c
 jr nz,FadeLoop07
 call IonFastCopy
 pop bc
 pop hl
 push hl
 push bc
FadeLoop16:
 res 1,(hl)
 res 6,(hl)
 inc hl
 dec bc
 ld a,b
 or c
 jr nz,FadeLoop16
 call IonFastCopy
 pop bc
 pop hl
 push hl
 push bc
FadeLoop25:
 res 2,(hl)
 res 5,(hl)
 inc hl
 dec bc
 ld a,b
 or c
 jr nz,FadeLoop25
 call IonFastCopy
 pop bc
 pop hl
FadeLoop34:
 res 3,(hl)
 res 4,(hl)
 inc hl
 dec bc
 ld a,b
 or c
 jr nz,FadeLoop34
 jp IonFastCopy
 
DrawSquare:
 call GetAns3 ; X1
 ld d,e
 push de
 call GetAns4 ; Y1
 ld a,e
 pop de
 ld e,a
 push de
 call GetAns5 ; X2
 ld d,e
 push de
 call GetAns6 ; Y2
 ld a,e
 pop de
 ld e,a
 push de
 call GetAns2 ; ID
 ld a,e
 pop de
 pop hl
 or a
 call z,RectBorder
 cp 1
 call z,ClrRect
 cp 2
 call z,FillRect
 cp 3
 call z,InvRect
 cp 4
 call z,RectBorderClr
 cp 5
 call z,EraseRect
 ret
 
RectBorder:
 rst 28h
.dw _DrawRectBorder ;Draw a rectangle (Upper Left L,H, Lower Right E,D)
 ret
 
ClrRect:
 rst 28h
.dw _ClearRect
 ret

FillRect:
 rst 28h
.dw _FillRect
 ret

InvRect:
 rst 28h
.dw _InvertRect
 ret

RectBorderClr:
 rst 28h
.dw _DrawRectBorderClr
 ret

EraseRect:
 rst 28h
.dw _EraseRectBorder
 ret
 
AlphaLock:
 set 4,(iy+18)  ; it off, so turn it on
 set 6,(iy+18)  ; it off, so turn it on
 ret            ; return
 
InvText:
 bit 3,(iy+5) ; is text inverted
 jr nz,ResInv ; yes, reset it to normal
 set 3,(iy+5) ; no, invert it
 ret          ; return

ResInv:
 res 3,(iy+5) ; normal text
 ret          ; return
 
ShiftUp:
 ld hl,_plotscreen+12
 ld de,_plotscreen
 ld bc,756
 ldir
 ex de,hl
 jp ShowNewUD

ShiftDown:
 ld hl,_plotscreen+767-12
 ld de,_plotscreen+767
 ld bc,756
 lddr
 inc hl
ShowNewUD:
 ld bc,12
 rst 28h
.dw _MemClear
 jp IonFastCopy

ShiftRight:
 ld hl,_plotscreen
 ld c,64
SRloop:
 ld b,12
 or a
sSRloop:
 rr (hl)
 inc hl
 djnz sSRloop
 dec c
 jr nz,SRloop
 jp IonFastCopy

ShiftLeft:
 ld hl,_plotscreen+767
 ld c,64
SLloop:
 ld b,12
 or a
sSLloop:
 rl (hl)
 dec hl
 djnz sSLloop
 dec c
 jr nz,SLloop
 
IonFastCopy:
 di
 ld a,$80
 out (16),a
 ld hl,_plotscreen+755
 ld a,32
 ld c,a
 inc hl
 dec hl
fastCopyAgain2:
 ld b,64
 inc c
 ld de,-767
 out (16),a
 add hl,de
 ld de,10
fastCopyLoop2:
 add hl,de
 inc hl
 inc hl
 inc de
 ld a,(hl)
 out (17),a
 dec de
 djnz fastCopyLoop2
 ld a,c
 cp 44
 jr nz,fastCopyAgain2
 ret

GetAns:
 rst 28h
.dw _RclAns
 ret
 
GetAns1:
 call GetAns
 ld hl,1
 jp CheckIt
 
GetAns2:
 call GetAns
 ld hl,2
 jp CheckIt

GetAns3:
 call GetAns
 ld hl,3
 jp CheckIt

GetAns4:
 call GetAns
 ld hl,4
 jp CheckIt
 
GetAns5:
 call GetAns
 ld hl,5
 jp CheckIt
 
GetAns6:
 call GetAns
 ld hl,6
 jp CheckIt
 
GetAns7:
 call GetAns
 ld hl,7
 jp CheckIt

GetAns8:
 call GetAns
 ld hl,8
 jp CheckIt
 
GetAns9:
 call GetAns
 ld hl,9
 jp CheckIt
 
GetAns10:
 call GetAns
 ld hl,10
 jp CheckIt
 
GetAns11:
 call GetAns
 ld hl,11
CheckIt:
 rst 28h
.dw _GetLtoOP1
 rst 28h
.dw _ConvOP1
 ret

Inverse:
 ld hl,_plotscreen
 ld bc,3
InvLoop:
 ld a,(hl)
 cpl
 ld (hl),a
 inc hl
 djnz InvLoop
 dec c
 jr nz,InvLoop
 jp IonFastCopy ; copy to screen & exit program

UserSprite:
 ld hl,_SaveSScreen
 push hl
 call GetAns4
 pop hl
 inc hl
 ld (hl),e
 push hl
 call GetAns5
 pop hl
 inc hl
 ld (hl),e
 push hl
 call GetAns6
 pop hl
 inc hl
 ld (hl),e
 push hl
 call GetAns7
 pop hl
 inc hl
 ld (hl),e
 push hl
 call GetAns8
 pop hl
 inc hl
 ld (hl),e
 push hl
 call GetAns9
 pop hl
 inc hl
 ld (hl),e
 push hl
 call GetAns10
 pop hl
 inc hl
 ld (hl),e
 push hl
 call GetAns11
 pop hl
 inc hl
 ld (hl),e
 call GetAns2
 ld d,e
 push de
 call GetAns3
 pop de
 ld e,a
 ld hl,_SaveSScreen
 call ClipSprite_XOR
 jp IonFastCopy

ClipSprite_XOR:
 ld a,8
 ld b,a
 ld a,e
 cp $80
 jr c,_PosY
 neg
 cp 8
 ret p
 ld c,a
 neg
 add a,8
 ld b,0
 add hl,bc
 ld e,b
 ld b,a
_PosY:
 cp 64
 ret nc
_ClipBtm:
 add a,b
 sub 65
 jr c,_DoHoriz
 sub b
 cpl
 ld b,a
_DoHoriz:
 ld a,d
 cp $80
 jr c,_PosX
 cp -7
 ret c
 ld ix,_ClipLeft
 jr _Patch
_PosX:
 cp 96
 ret nc
 cp 89
 ld ix,_ClipRight
 jr c,_DoSprite
_Patch:
 ld (ix),0
_DoSprite:
 di
 inc hl
 push hl
 sla e
 sla e
 ld h,0
 ld l,e
 ld d,h
 add hl,hl
 add hl,de
 ld e,a
 sra e
 sra e
 sra e
 jp p,_Pos
 dec d
_Pos:
 add hl,de
 ld de,_plotscreen
 add hl,de
 pop de
 and 7
 ld (_save),sp
 ld sp,11
 jr z,_Aligned
 dec a
 ld c,a
 add a,a
 add a,c
 ld (_Jump),a
_Loop:
 ld a,(de)
 ld c,a
 xor a
_Jump   =$+1
 jr $
 sla c
 rla
 sla c
 rla
 sla c
 rla
 sla c
 rla
 sla c
 rla
 sla c
 rla
 sla c
 rla
 xor (hl)
_ClipLeft:
 ld (hl),a
 inc hl
 ld a,c
 xor (hl)
_ClipRight:
 ld (hl),a
 inc de
 add hl,sp
 djnz _Loop
 ld (ix),$77
_Done:
_save   =$+1
 ld sp,0
 ret
_Aligned:
 inc sp
_ALoop:
 ld a,(de)
 xor (hl)
 ld (hl),a
 inc de
 add hl,sp
 djnz _ALoop
 jp _Done
 
NoDone:
 res 5,(iy) ; iy+0
 ret

;#include "Pics.inc"

.end